/**********************************************************************************
*   this file is part of c2h
*   Copyright (C)2005 Bruce Park ( jongsuknim@naver.com )
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either
*   version 2 of the License, or (at your option) any later version.
*
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
***********************************************************************************/
#ifndef   _JSCRIPT_SYNTEX_H
#define   _JSCRIPT_SYNTEX_H


#define  JSCRIPT_LINE_COMMENT	"//"
#define  JSCRIPT_BLOCK_COMMENT_ON	"/*",0
#define  JSCRIPT_BLOCK_COMMENT_OFF	"*/",0
#define  JSCRIPT_STRING_CHARS	"\"\'"
#define  JSCRIPT_FILE_EXTENSIONS	"JS","ASP",0
#define  JSCRIPT_DELIMITERS	"\r\n~!@%^&*()-+=|\\/{}[]:;\"\'<> ,	.?"
#define  JSCRIPT_KEYWORDS	"is",\
"new",\
"sizeof",\
"typeof",\
"unchecked",\
"abstract",\
"break","byte",\
"case","catch","char","class","const","continue",\
"default","delete","do","double",\
"else","extends",\
"false","final","finally","float","for","function",\
"goto",\
"if","implements","import","in","instanceof","int","interface",\
"long",\
"native","null",\
"package","private","protected","public",\
"reset","return",\
"short","static","super","switch","synchronized",\
"this","throw","transient","true","try",\
"var","void",\
"while","with",0
#define  JSCRIPT_KEYWORDS1	"Anchor","Applet","Area","Arguments","Array",\
"Boolean","Button",\
"Checkbox","Collection","Crypto",\
"Date","Dictionary","Document","Drive","Drives",\
"Element","Enumerator","Event",\
"File","FileObject","FileSystemObject","FileUpload","Folder","Folders","Form","Frame","Function",\
"Global",\
"Hidden","History","HTMLElement",\
"Image","Infinity","Input",\
"JavaArray","JavaClass","JavaObject","JavaPackage","JSObject",\
"Layer","Link",\
"Math","MimeType",\
"Navigator","Number",\
"Object","Option",\
"Packages","Password","Plugin","PrivilegeManager",\
"Random","RegExp",\
"Screen","Select","String","Submit",\
"Text","Textarea",\
"URL",\
"VBArray",\
"Window","WScript",0
#define  JSCRIPT_KEYWORDS2	"above","abs","acos","action","activeElement","alert","alinkColor","all","altKey","anchor","anchors","appCodeName","applets","apply","appName","appVersion","arguments","arity","asin","assign","atan","atan2","atob",\
"availHeight","availLeft","availTop","availWidth",\
"ActiveXObject",\
"back","background","below","bgColor","big","blink","blur","bold","border","borderWidths","bottom","btoa","button",\
"call","callee","caller","cancelBubble","captureEvents","ceil","charAt","charCodeAt","charset","checked","children","classes","className","clear","clearInterval","clearTimeout","click","clientInformation",\
"clientX","clientY","close","closed","colorDepth","compile","complete","concat","confirm","constructir","contains","contextual","cookie","cos","crypto","ctrlKey","current",\
"data","defaultCharset","defaultChecked","defaultSelected","defaultStatus","defaultValue","description","disableExternalCapture","disablePrivilege","document","domain",\
"E","Echo",\
"element","elements","embeds","enabledPlugin","enableExternalCapture","enablePrivilege","encoding","escape","eval","event","exec","exp","expando",\
"FromPoint",\
"fgColor","fileName","find","fixed","floor","focus","fontColor","fontSize","form","forms","forward","frames","fromCharCode","fromElement",\
"getAttribute","get","getClass","getDate","getDay","getFullYear","getHours","getMember","getMilliseconds","getMinutes","getMonth","getSeconds","getSelection","getSlot","getTime","getTimezoneOffset",\
"getUTCDate","getUTCDay","getUTCFullYear","getUTCHours","getUTCMilliseconds","getUTCMinutes","getUTCMonth","getUTCSeconds","getWindow","getYear","global","go",\
"HandleEvent","Height",\
"hash","hidden","history","home","host","hostName","href","hspace",\
"id","ids","ignoreCase","images","index","indexOf","inner","innerHTML","innerText","innerWidth","insertAdjacentHTML","insertAdjacentText","isFinite","isNaN","italics",\
"java","javaEnabled","join",\
"keyCode",\
"Links","LN10","LN2","LOG10E","LOG2E",\
"lang","language","lastIndex","lastIndexOf","lastMatch","lastModified","lastParen","layers","layerX","layerY","left","leftContext","length","link","linkColor","load","location","locationBar","log","lowsrc",\
"MAX_VALUE","MIN_VALUE",\
"margins","match","max","menubar","method","mimeTypes","min","modifiers","moveAbove","moveBelow","moveBy","moveTo","moveToAbsolute","multiline",\
"NaN","NEGATIVE_INFINITY",\
"name","navigate","navigator","netscape","next","number",\
"offscreenBuffering","offset","offsetHeight","offsetLeft","offsetParent","offsetTop","offsetWidth","offsetX","offsetY","onabort","onblur","onchange","onclick","ondblclick","ondragdrop","onerror","onfocus",\
"onHelp","onkeydown","onkeypress","onkeyup","onload","onmousedown","onmousemove","onmouseout","onmouseover","onmouseup","onmove","onreset","onresize","onsubmit","onunload","open","opener","options","outerHeight",\
"outerHTML","outerText","outerWidth",\
"POSITIVE_INFINITY","PI",\
"paddings","pageX","pageXOffset","pageY","pageYOffset","parent","parentElement","parentLayer","parentWindow","parse","parseFloat","parseInt","pathname","personalbar","pixelDepth","platform","plugins","pop",\
"port","pow","preference","previous","print","prompt","protocol","prototype","push",\
"random","readyState","reason","referrer","refresh","releaseEvents","reload","removeAttribute","removeMember","replace","resizeBy","resizeTo","returnValue","reverse","right","rightcontext","round",\
"SQRT1_2","SQRT2",\
"screenX","screenY","scroll","scrollbars","scrollBy","scrollIntoView","scrollTo","search","select","selected","selectedIndex","self","setAttribute","setDay","setFullYear","setHotkeys","setHours","setInterval",\
"setMember","setMilliseconds","setMinutes","setMonth","setResizable","setSeconds","setSlot","setTime","setTimeout","setUTCDate","setUTCFullYear","setUTCHours","setUTCMillseconds","setUTCMinutes",\
"setUTCMonth","setUTCSeconds","setYear","setZOptions","shift","shiftKey","siblingAbove","siblingBelow","signText","sin","slice","smallsort","source","sourceIndex","splice","split","sqrt","src",\
"srcElement","srcFilter","status","statusbar","stop","strike","style","sub","submit","substr","substring","suffixes","sun","sup","systemLanguage",\
"TYPE",\
"tagName","tags","taint","taintEnabled","tan","target","test","text","title","toElement","toGMTString","toLocaleString","toLowerCase","toolbar","top","toString","toUpperCase","toUTCString","type","typeof",\
"UTC",\
"unescape","unshift","untaint","unwatch","userAgent","userLanguage",\
"value","valueOf","visibility","vlinkColor","vspace",\
"watch","which","width","window","write","writeln",\
"x",\
"y",\
"zIndex",0


#endif
